package com.ruoyi.pay.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.pay.domain.bo.PayProductMaterialBo;
import com.ruoyi.pay.domain.vo.PayProductMaterialVo;
import com.ruoyi.pay.domain.PayProductMaterial;
import com.ruoyi.pay.mapper.PayProductMaterialMapper;
import com.ruoyi.pay.service.IPayProductMaterialService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 产品毛料关联Service业务层处理
 *
 * @author ruoyi
 * @date 2025-05-12
 */
@RequiredArgsConstructor
@Service
public class PayProductMaterialServiceImpl implements IPayProductMaterialService {

    private final PayProductMaterialMapper baseMapper;

    /**
     * 查询产品毛料关联
     */
    @Override
    public PayProductMaterialVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询产品毛料关联列表
     */
    @Override
    public TableDataInfo<PayProductMaterialVo> queryPageList(PayProductMaterialBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PayProductMaterial> lqw = buildQueryWrapper(bo);
        Page<PayProductMaterialVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询产品毛料关联列表
     */
    @Override
    public List<PayProductMaterialVo> queryList(PayProductMaterialBo bo) {
        LambdaQueryWrapper<PayProductMaterial> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PayProductMaterial> buildQueryWrapper(PayProductMaterialBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PayProductMaterial> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getTenantId() != null, PayProductMaterial::getTenantId, bo.getTenantId());
        lqw.eq(bo.getMaterialId() != null, PayProductMaterial::getMaterialId, bo.getMaterialId());
        lqw.eq(bo.getProductId() != null, PayProductMaterial::getProductId, bo.getProductId());
        return lqw;
    }

    /**
     * 新增产品毛料关联
     */
    @Override
    public Boolean insertByBo(PayProductMaterialBo bo) {
        PayProductMaterial add = BeanUtil.toBean(bo, PayProductMaterial.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改产品毛料关联
     */
    @Override
    public Boolean updateByBo(PayProductMaterialBo bo) {
        PayProductMaterial update = BeanUtil.toBean(bo, PayProductMaterial.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PayProductMaterial entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除产品毛料关联
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
